#define STATE_NONE 0
#define STATE_MULTIPART_ALL 2
#define STATE_MULTIPART_SOME 4
#define STATE_DOWNLOAD_QUEUED 8
#define STATE_DECODE_QUEUED 16
#define STATE_READ 32
#define STATE_DECODED 64
#define STATE_ERROR 128

typedef struct _article_data article_data;
struct _article_data {
    // Header
    gchar *number;
    gchar *subject;
    gchar *author;
    gchar *message_id;
    gchar *references;
    time_t date;
    gint linecount;
    // Multipart Info
    gint parts;
    gint part;
    // Threads
    gint nthreads;
    GSList *threads;
    // The Header
    gchar *header;
    // The Body
    gchar *body;
    // From Group
    group_data *group;
    gint state;
    GtkCTreeNode *node;
};
gchar *extract_header(article_data *, gchar *);
void article_free(article_data *);
void article_free_protected(article_data *);
article_data *article_in_memory(gchar *);
void article_update(article_data *);
article_data *article_copy(article_data *);
