/*
 * Pan - A Newsreader for X
 * Copyright (C) 1999  Matt Eagleson (e.Messiah@superpimp.org)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

#include <gnome.h>
#include <gtk/gtk.h>
#include "pan.h"
#include "post.h"

GtkWidget *
menu_create(GtkWidget * window)
{
    void gnome_stock_menu_accel_dlg(char *);
    GtkWidget *menubar, *w, *menu;
    GtkAccelGroup *accel;
    guchar key;
    guint8 mod;

    accel = gtk_accel_group_new();
    menubar = gtk_menu_bar_new();
    gtk_widget_show(menubar);

    menu = gtk_menu_new();
    
    w = gnome_stock_menu_item(GNOME_STOCK_MENU_QUIT, _("Quit"));
    gtk_widget_show(w);
    if (gnome_stock_menu_accel(GNOME_STOCK_MENU_QUIT, &key, &mod))
	gtk_widget_add_accelerator(w, "activate", accel, key, mod, 0);

    gtk_signal_connect_object(GTK_OBJECT(w), "activate",
			      (GtkSignalFunc) pan_shutdown,
			      GTK_OBJECT(window));
    gtk_menu_append(GTK_MENU(menu), w);

    w = gtk_menu_item_new_with_label(_("File"));
    gtk_widget_show(w);
    gtk_menu_item_set_submenu(GTK_MENU_ITEM(w), menu);
    gtk_menu_bar_append(GTK_MENU_BAR(menubar), w);

    menu = gtk_menu_new();
    
    w = gnome_stock_menu_item(GNOME_STOCK_MENU_PROP, _("Properties..."));
    gtk_widget_show(w);
    if (gnome_stock_menu_accel(GNOME_STOCK_MENU_PROP, &key, &mod))
	gtk_widget_add_accelerator(w, "activate", accel, key, mod, 0);

    gtk_signal_connect(GTK_OBJECT(w), "activate",
		       GTK_SIGNAL_FUNC(properties_spawn), NULL);
    gtk_menu_append(GTK_MENU(menu), w);
    
    w = gtk_menu_item_new_with_label(_("Edit"));
    gtk_widget_show(w);
    gtk_menu_item_set_submenu(GTK_MENU_ITEM(w), menu);
    gtk_menu_item_right_justify(GTK_MENU_ITEM(w));
    gtk_menu_bar_append(GTK_MENU_BAR(menubar), w);

    menu = gtk_menu_new();

    server_menu_create(menu);
    
    w = gtk_menu_item_new_with_label(_("Servers"));
    gtk_widget_show(w);
    gtk_menu_item_set_submenu(GTK_MENU_ITEM(w), menu);
    gtk_menu_bar_append(GTK_MENU_BAR(menubar), w);

    menu = gtk_menu_new();

    w = gtk_menu_item_new_with_label(_("Post New Message..."));
    gtk_widget_show(w);
    gtk_signal_connect(GTK_OBJECT(w), "activate",
		       GTK_SIGNAL_FUNC(post_window), NULL);
    gtk_menu_append(GTK_MENU(menu), w);

    w = gtk_menu_item_new_with_label(_("Post Followup Message..."));
    gtk_widget_show(w);
    gtk_signal_connect(GTK_OBJECT(w), "activate",
		       GTK_SIGNAL_FUNC(followup_window), NULL);
    gtk_menu_append(GTK_MENU(menu), w);

    w = gtk_menu_item_new_with_label(_("Post"));
    gtk_widget_show(w);
    gtk_menu_item_set_submenu(GTK_MENU_ITEM(w), menu);
    gtk_menu_bar_append(GTK_MENU_BAR(menubar), w);

    menu = gtk_menu_new();

    w = gtk_menu_item_new_with_label(_("Stop all Online Tasks"));
    gtk_widget_show(w);
    gtk_signal_connect(GTK_OBJECT(w), "activate",
		       GTK_SIGNAL_FUNC(stop_all_online_tasks), NULL);
    gtk_menu_append(GTK_MENU(menu), w);

    w = gtk_menu_item_new();
    gtk_widget_show(w);
    gtk_menu_append(GTK_MENU(menu), w);

    w = gtk_menu_item_new_with_label(_("Get all Groups"));
    gtk_widget_show(w);
    gtk_signal_connect(GTK_OBJECT(w), "activate",
		       GTK_SIGNAL_FUNC(get_all_groups), NULL);
    gtk_menu_append(GTK_MENU(menu), w);

    w = gtk_menu_item_new();
    gtk_widget_show(w);
    gtk_menu_append(GTK_MENU(menu), w);

    w = gtk_menu_item_new_with_label(_("Get All Article Headers"));
    gtk_widget_show(w);
    gtk_signal_connect(GTK_OBJECT(w), "activate",
		       GTK_SIGNAL_FUNC(articlelist_get_all), NULL);
    gtk_menu_append(GTK_MENU(menu), w);

    w = gtk_menu_item_new_with_label(_("Get New Article Headers"));
    gtk_widget_show(w);
    gtk_signal_connect(GTK_OBJECT(w), "activate",
		       GTK_SIGNAL_FUNC(articlelist_get_new), NULL);
    gtk_menu_append(GTK_MENU(menu), w);

    w = gtk_menu_item_new_with_label(_("Online"));
    gtk_widget_show(w);
    gtk_menu_item_set_submenu(GTK_MENU_ITEM(w), menu);
    gtk_menu_bar_append(GTK_MENU_BAR(menubar), w);

    menu = gtk_menu_new();

    w = gnome_stock_menu_item(GNOME_STOCK_MENU_ABOUT, _("About"));
    gtk_widget_show(w);
    if (gnome_stock_menu_accel(GNOME_STOCK_MENU_ABOUT, &key, &mod))
	gtk_widget_add_accelerator(w, "activate", accel, key, mod, 0);
    gtk_signal_connect_object(GTK_OBJECT(w), "activate",
			      (GtkSignalFunc) gui_about,
			      GTK_OBJECT(window));

    gtk_menu_append(GTK_MENU(menu), w);

    w = gtk_menu_item_new_with_label(_("Help"));
    gtk_widget_show(w);
    gtk_menu_item_set_submenu(GTK_MENU_ITEM(w), menu);
    gtk_menu_item_right_justify(GTK_MENU_ITEM(w));
    gtk_menu_bar_append(GTK_MENU_BAR(menubar), w);

    gtk_window_add_accel_group(GTK_WINDOW(window), accel);

    return menubar;
}
