/*
 * Pan - A Newsreader for X
 * Copyright (C) 1999  Matt Eagleson (e.Messiah@superpimp.org)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

#include <string.h>
#include <signal.h>
#include <gnome.h>
#include <gtk/gtk.h>
#include <libgnomeui/gnome-stock.h>
#include <pthread.h>
#include "pan.h"

// Global Application Structure
struct _Pan Pan;

void
pan_init(void)
{
    /* Initialize Variables in Global Application 
       structure to Sane defaults.
     */

    Pan.grouplist = NULL;
    Pan.displayed_group = NULL;
    Pan.error = NULL;

    Pan.props = (Props *) g_malloc(sizeof(Props));
    memset(Pan.props, 0, sizeof(Props));
}

int
main(int argc, char *argv[])
{
    g_thread_init(NULL);
    gnome_init("Pan", VERSION, argc, argv);
	pan_init();
	
	gui_construct();

    /* Check if a Preferences file exists. */
    if (!gnome_config_has_section("/Pan/User")) {
        guru_spawn();
    } else {
        load_properties(Pan.props);
		server_init();
		db_open();
    }
    
	gdk_threads_enter();
    gtk_main();

    return 0;
}

void
pan_shutdown(void)
{
    tcp_close();
    gui_set_status(_("Closing article database..."));
    db_close();
    if (Pan.grouplist)
		grouplist_save();
    gtk_main_quit();
}
